{
  "x-generator": "On Key REST API Docs Generator",
  "swagger": "2.0",
  "info": {
    "title": "On Key AHM  API Specification",
    "description": "Better and smarter enterprise asset management with one of the world's leading Enterprise Asset Management (EAM) systems.",
    "termsOfService": "https://www.onkey.com/",
    "contact": {
      "name": "On Key Support",
      "url": "https://www.onkey.com/",
      "email": "onkey.support@pragmaworld.net"
    },
    "license": {
      "name": "On Key Licence",
      "url": "https://www.onkey.com/"
    },
    "version": "1.0.0"
  },
  "host": "<variable>:443",
  "basePath": "/api/tenants/{client}/{connection}",
  "schemes": [
    "https"
  ],
  "consumes": [
    "application/vnd.onkey.entity+json",
    "application/vnd.onkey.entitypatch+json",
    "application/vnd.onkey.entitycollection+json",
    "application/vnd.onkey.entitypatchcollection+json",
    "application/vnd.onkey.entitydelete+json",
    "application/vnd.onkey.entitydeletecollection+json"
  ],
  "produces": [
    "application/vnd.onkey.entity+json",
    "application/vnd.onkey.notification+json",
    "application/vnd.onkey.entitycollectionpage+json",
    "application/vnd.onkey.entitycollection+json"
  ],
  "paths": {
    "/Modules/AHM/Alarms/{id}": {
      "get": {
        "tags": [
          "Alarm"
        ],
        "summary": "Get a Alarm resource.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| createdByUserId | Alarm->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | Alarm->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | Alarm->CreatedByUser_FullName | string |  |\r\n| createdOn | Alarm->CreatedOn | string | date-time |\r\n| modifiedByUserId | Alarm->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | Alarm->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | Alarm->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | Alarm->ModifiedOn | string | date-time |\r\n| version | Alarm->Version | integer | int32 |\r\n| permissionTreeId | Alarm->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | Alarm->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | Alarm->PermissionTree_Description | string |  |\r\n| id | Alarm->Id | integer | int64 |\r\n| alarmTypeId | Alarm->AlarmType_Id | integer | int64 |\r\n| alarmTypeCode | Alarm->AlarmType_Code | string |  |\r\n| alarmTypeDescription | Alarm->AlarmType_Description | string |  |\r\n| assetId | Alarm->Asset_Id | integer | int64 |\r\n| assetCode | Alarm->Asset_Code | string |  |\r\n| assetDescription | Alarm->Asset_Description | string |  |\r\n| assetRecordType | Alarm->Asset_RecordType | string (Allowed values: [Regular, InPlace, EmptyPlaceholder, LinkedPlaceholder]) | enum |\r\n| classification | Alarm->Classification | string (Allowed values: [Information, Warning, Error]) | enum |\r\n| description | Alarm->Description | string |  |\r\n| exceededBound | Alarm->ExceededBound | string (Allowed values: [UpperCritical, UpperWarning, LowerWarning, LowerCritical]) | enum |\r\n| monitoringPointId | Alarm->MonitoringPoint_Id | integer | int64 |\r\n| monitoringPointCode | Alarm->MonitoringPoint_Code | string |  |\r\n| monitoringPointDescription | Alarm->MonitoringPoint_Description | string |  |\r\n| monitoringPointIsCalculated | Alarm->MonitoringPoint_IsCalculated | boolean |  |\r\n| monitoringPointMonitoringPointTypeId | Alarm->MonitoringPoint_MonitoringPointType_Id | integer | int64 |\r\n| monitoringPointMonitoringPointTypeCode | Alarm->MonitoringPoint_MonitoringPointType_Code | string |  |\r\n| monitoringPointMonitoringPointTypeDescription | Alarm->MonitoringPoint_MonitoringPointType_Description | string |  |\r\n| notes | Alarm->Notes | string |  |\r\n| sequenceNumber | Alarm->SequenceNumber | integer | int32 |\r\n| source | Alarm->Source | string (Allowed values: [Manual, StandaloneTriggerExpression, AssetRegisterTriggerExpression]) | enum |\r\n| status | Alarm->Status | string (Allowed values: [Active, Acknowledged, Closed, Cancelled, ClosedBySystem]) | enum |\r\n| workOrderGenerated | Alarm->WorkOrderGenerated | boolean |  |\r\n",
        "operationId": "GetAlarm",
        "produces": [
          "application/vnd.onkey.entity+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Alarm Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Alarm",
            "schema": {
              "$ref": "#/definitions/GetMonitorPointTypeResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Alarm"
        ],
        "summary": "Update an existing Alarm resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Alarm->Version | integer | int32 |\r\n| assetId | Alarm->Asset_Id | integer | int64 |\r\n| alarmTypeId | Alarm->AlarmType_Id | integer | int64 |\r\n| classification | Alarm->Classification | string (Allowed values: [Information, Warning, Error]) | enum |\r\n| description | Alarm->Description | string |  |\r\n| notes | Alarm->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| alarmTypeId | Nullable | False |  |\r\n| classification | Nullable | False |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 500 chars|  |\r\n| notes | Read-only | True | Alarm->Status EQ 'Cancelled' OR Alarm->Status EQ 'ClosedBySystem' OR Alarm->Status EQ 'Closed' |\r\n\r\n",
        "operationId": "UpdateAlarm",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Alarm Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/UpdateAlarmResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Alarm was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms": {
      "get": {
        "tags": [
          "Alarm"
        ],
        "summary": "Get a collection of Alarm resources.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Alarm->Version | integer | int32 |\r\n| id | Alarm->Id | integer | int64 |\r\n| description | Alarm->Description | string |  |\r\n| assetId | Alarm->Asset_Id | integer | int64 |\r\n| assetCode | Alarm->Asset_Code | string |  |\r\n| assetDescription | Alarm->Asset_Description | string |  |\r\n| alarmTypeId | Alarm->AlarmType_Id | integer | int64 |\r\n| alarmTypeCode | Alarm->AlarmType_Code | string |  |\r\n| alarmTypeDescription | Alarm->AlarmType_Description | string |  |\r\n| workOrderGenerated | Alarm->WorkOrderGenerated | boolean |  |\r\n| status | Alarm->Status | string (Allowed values: [Active, Acknowledged, Closed, Cancelled, ClosedBySystem]) | enum |\r\n| notes | Alarm->Notes | string |  |\r\n| createdOn | Alarm->CreatedOn | string | date-time |\r\n| modifiedOn | Alarm->ModifiedOn | string | date-time |\r\n| sequenceNumber | Alarm->SequenceNumber | integer | int32 |\r\n",
        "operationId": "GetAlarmCollection",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Alarm collection",
            "schema": {
              "$ref": "#/definitions/GetAlarmCollectionResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "post": {
        "tags": [
          "Alarm"
        ],
        "summary": "Create a new Alarm resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| alarmTypeId | Alarm->AlarmType_Id | integer | int64 |\r\n| assetId | Alarm->Asset_Id | integer | int64 |\r\n| classification | Alarm->Classification | string (Allowed values: [Information, Warning, Error]) | enum |\r\n| description | Alarm->Description | string |  |\r\n| permissionTreeId | Alarm->PermissionTree_Id | integer | int64 |\r\n| notes | Alarm->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| alarmTypeId | Required | True |  |\r\n| alarmTypeId | Nullable | False |  |\r\n| classification | Nullable | False |  |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 500 chars|  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "CreateAlarm",
        "consumes": [
          "application/vnd.onkey.entity+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "post",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/CreateAlarmResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - resource was successfully created",
            "headers": {
              "OnKey-Resource-Id": {
                "type": "integer",
                "description": "Id of the resource created",
                "format": "Int64"
              },
              "OnKey-Resource-Location": {
                "type": "string",
                "description": "Uri to fetch the created resource"
              }
            }
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Lookups/LookupAlarmAlarmType": {
      "get": {
        "tags": [
          "Alarm"
        ],
        "summary": "Lookup the Alarm Type for the Alarm.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | AlarmType->Id | integer | int64 |\r\n| code | AlarmType->Code | string |  |\r\n| description | AlarmType->Description | string |  |\r\n",
        "operationId": "LookupAlarmAlarmType",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Alarm Type collection",
            "schema": {
              "$ref": "#/definitions/AlarmAlarmTypeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Lookups/LookupAlarmAsset": {
      "get": {
        "tags": [
          "Alarm"
        ],
        "summary": "Lookup the Asset for the Alarm.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Asset->Id | integer | int64 |\r\n| code | Asset->Code | string |  |\r\n| description | Asset->Description | string |  |\r\n| recordType | Asset->RecordType | string (Allowed values: [Regular, InPlace, EmptyPlaceholder, LinkedPlaceholder]) | enum |\r\n",
        "operationId": "LookupAlarmAsset",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Asset collection",
            "schema": {
              "$ref": "#/definitions/AlarmAssetLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Lookups/LookupAlarmChangePermissionTree": {
      "get": {
        "tags": [
          "Alarm"
        ],
        "summary": "Lookup the permission set for changing the Alarm.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupAlarmChangePermissionTree",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable  collection",
            "schema": {
              "$ref": "#/definitions/AlarmChangePermissionTreeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Lookups/LookupAlarmInsertPermissionTree": {
      "get": {
        "tags": [
          "Alarm"
        ],
        "summary": "Lookup the permission set for creating the Alarm.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupAlarmInsertPermissionTree",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable  collection",
            "schema": {
              "$ref": "#/definitions/AlarmInsertPermissionTreeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Batch/{ids}": {
      "get": {
        "tags": [
          "Alarm"
        ],
        "summary": "Get a collection of Alarm resources for the set of id's.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| createdByUserId | Alarm->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | Alarm->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | Alarm->CreatedByUser_FullName | string |  |\r\n| createdOn | Alarm->CreatedOn | string | date-time |\r\n| modifiedByUserId | Alarm->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | Alarm->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | Alarm->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | Alarm->ModifiedOn | string | date-time |\r\n| version | Alarm->Version | integer | int32 |\r\n| permissionTreeId | Alarm->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | Alarm->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | Alarm->PermissionTree_Description | string |  |\r\n| id | Alarm->Id | integer | int64 |\r\n| alarmTypeId | Alarm->AlarmType_Id | integer | int64 |\r\n| alarmTypeCode | Alarm->AlarmType_Code | string |  |\r\n| alarmTypeDescription | Alarm->AlarmType_Description | string |  |\r\n| assetId | Alarm->Asset_Id | integer | int64 |\r\n| assetCode | Alarm->Asset_Code | string |  |\r\n| assetDescription | Alarm->Asset_Description | string |  |\r\n| assetRecordType | Alarm->Asset_RecordType | string (Allowed values: [Regular, InPlace, EmptyPlaceholder, LinkedPlaceholder]) | enum |\r\n| classification | Alarm->Classification | string (Allowed values: [Information, Warning, Error]) | enum |\r\n| description | Alarm->Description | string |  |\r\n| exceededBound | Alarm->ExceededBound | string (Allowed values: [UpperCritical, UpperWarning, LowerWarning, LowerCritical]) | enum |\r\n| monitoringPointId | Alarm->MonitoringPoint_Id | integer | int64 |\r\n| monitoringPointCode | Alarm->MonitoringPoint_Code | string |  |\r\n| monitoringPointDescription | Alarm->MonitoringPoint_Description | string |  |\r\n| monitoringPointIsCalculated | Alarm->MonitoringPoint_IsCalculated | boolean |  |\r\n| monitoringPointMonitoringPointTypeId | Alarm->MonitoringPoint_MonitoringPointType_Id | integer | int64 |\r\n| monitoringPointMonitoringPointTypeCode | Alarm->MonitoringPoint_MonitoringPointType_Code | string |  |\r\n| monitoringPointMonitoringPointTypeDescription | Alarm->MonitoringPoint_MonitoringPointType_Description | string |  |\r\n| notes | Alarm->Notes | string |  |\r\n| sequenceNumber | Alarm->SequenceNumber | integer | int32 |\r\n| source | Alarm->Source | string (Allowed values: [Manual, StandaloneTriggerExpression, AssetRegisterTriggerExpression]) | enum |\r\n| status | Alarm->Status | string (Allowed values: [Active, Acknowledged, Closed, Cancelled, ClosedBySystem]) | enum |\r\n| workOrderGenerated | Alarm->WorkOrderGenerated | boolean |  |\r\n",
        "operationId": "BatchGetAlarm",
        "produces": [
          "application/vnd.onkey.entitycollection+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "array",
            "name": "ids",
            "in": "path",
            "required": true,
            "description": "A comma separated list of Alarm id's (eg. 1585760985950002,1585760985950003)",
            "collectionFormat": "csv",
            "x-nullable": false,
            "items": {
              "type": "integer",
              "format": "int64"
            }
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Alarm collection",
            "schema": {
              "$ref": "#/definitions/BatchGetAlarmsResourceAction"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Batch": {
      "post": {
        "tags": [
          "Alarm"
        ],
        "summary": "Create a new collection of Alarm resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| description | Alarm->Description | string |  |\r\n| alarmTypeId | Alarm->AlarmType_Id | integer | int64 |\r\n| assetId | Alarm->Asset_Id | integer | int64 |\r\n| classification | Alarm->Classification | string (Allowed values: [Information, Warning, Error]) | enum |\r\n| permissionTreeId | Alarm->PermissionTree_Id | integer | int64 |\r\n| notes | Alarm->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 500 chars|  |\r\n| alarmTypeId | Required | True |  |\r\n| alarmTypeId | Nullable | False |  |\r\n| classification | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchCreateAlarm",
        "consumes": [
          "application/vnd.onkey.entitycollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "posts",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchCreateAlarmRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - Alarm batch was successfully created"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Alarm"
        ],
        "summary": "Update a collection of existing Alarm resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Alarm->Id | integer | int64 |\r\n| version | Alarm->Version | integer | int32 |\r\n| alarmTypeId | Alarm->AlarmType_Id | integer | int64 |\r\n| description | Alarm->Description | string |  |\r\n| classification | Alarm->Classification | string (Allowed values: [Information, Warning, Error]) | enum |\r\n| assetId | Alarm->Asset_Id | integer | int64 |\r\n| notes | Alarm->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| alarmTypeId | Nullable | False |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 500 chars|  |\r\n| classification | Nullable | False |  |\r\n| notes | Read-only | True | Alarm->Status EQ 'Cancelled' OR Alarm->Status EQ 'ClosedBySystem' OR Alarm->Status EQ 'Closed' |\r\n\r\n",
        "operationId": "BatchUpdateAlarm",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchUpdateAlarmResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Alarm batch was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Batch/{alarmIds}/CreateWorkOrder": {
      "post": {
        "tags": [
          "Alarm"
        ],
        "summary": "Batch Create Work Order for Alarms",
        "description": "",
        "operationId": "BatchCreateWorkOrderForAlarm",
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "array",
            "name": "alarmIds",
            "in": "path",
            "required": true,
            "description": "A comma separated list of Alarm id's (eg. 1585760985950002,1585760985950003)",
            "collectionFormat": "csv",
            "x-nullable": false,
            "items": {
              "type": "integer",
              "format": "int64"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/{id}/PermissionTree": {
      "patch": {
        "tags": [
          "Alarm"
        ],
        "summary": "Change the PermissionTree for an existing Alarm resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Alarm->Version | integer | int32 |\r\n| permissionTreeId | Alarm->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeAlarmPermissionTree",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Alarm Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/ChangeAlarmPermissionTreeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/{id}/Status": {
      "patch": {
        "tags": [
          "Alarm"
        ],
        "summary": "Change Alarm Status",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | ChangeAlarmStatus->Version | integer | int32 |\r\n| status | ChangeAlarmStatus->Status | string (Allowed values: [Active, Acknowledged, Closed, Cancelled, ClosedBySystem]) | enum |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| status | Required | True |  |\r\n| status | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeAlarmStatus",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Alarm Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/ChangeAlarmStatusResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/{id}/CreateWorkOrder": {
      "post": {
        "tags": [
          "Alarm"
        ],
        "summary": "Create Work Order For Alarm.",
        "description": "",
        "operationId": "CreateWorkOrderForAlarm",
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Alarm Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Batch/PermissionTree": {
      "patch": {
        "tags": [
          "Alarm"
        ],
        "summary": "Change the PermissionTree status for a collection of existing Alarm resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Alarm->Id | integer | int64 |\r\n| version | Alarm->Version | integer | int32 |\r\n| permissionTreeId | Alarm->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeAlarmPermissionTree",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchChangeAlarmPermissionTreeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Status/Batch": {
      "post": {
        "tags": [
          "Alarm"
        ],
        "summary": "Change the status for a collection of Alarm resources",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | ChangeAlarmStatus->Id | integer | int64 |\r\n| version | ChangeAlarmStatus->Version | integer | int32 |\r\n| status | ChangeAlarmStatus->Status | string (Allowed values: [Active, Acknowledged, Closed, Cancelled, ClosedBySystem]) | enum |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| status | Required | True |  |\r\n| status | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeAlarmStatus",
        "consumes": [
          "application/vnd.onkey.entitycollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "posts",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchChangeAlarmStatusResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Attributes/{id}": {
      "get": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Get a Alarm Attribute resource.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| alarmId | AlarmAttribute->Alarm_Id | integer | int64 |\r\n| alarmDescription | AlarmAttribute->Alarm_Description | string |  |\r\n| createdByUserId | AlarmAttribute->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | AlarmAttribute->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | AlarmAttribute->CreatedByUser_FullName | string |  |\r\n| createdOn | AlarmAttribute->CreatedOn | string | date-time |\r\n| isActive | AlarmAttribute->IsActive | boolean |  |\r\n| modifiedByUserId | AlarmAttribute->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | AlarmAttribute->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | AlarmAttribute->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | AlarmAttribute->ModifiedOn | string | date-time |\r\n| permissionTreeId | AlarmAttribute->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | AlarmAttribute->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | AlarmAttribute->PermissionTree_Description | string |  |\r\n| version | AlarmAttribute->Version | integer | int32 |\r\n| id | AlarmAttribute->Id | integer | int64 |\r\n| attributeId | AlarmAttribute->Attribute_Id | integer | int64 |\r\n| attributeCode | AlarmAttribute->Attribute_Code | string |  |\r\n| attributeDescription | AlarmAttribute->Attribute_Description | string |  |\r\n| attributeAllowAnyValue | AlarmAttribute->Attribute_AllowAnyValue | boolean |  |\r\n| attributeDataType | AlarmAttribute->Attribute_DataType | string (Allowed values: [String, Email, Integer, Long, Float, Currency, DateTime, Date, Time, Duration, Boolean]) | enum |\r\n| attributeDefaultValue | AlarmAttribute->Attribute_DefaultValue | object | composite |\r\n| attributeDefaultAllowedValueId | AlarmAttribute->Attribute_DefaultAllowedValue_Id | integer | int64 |\r\n| attributeDefaultAllowedValueDescription | AlarmAttribute->Attribute_DefaultAllowedValue_Description | string |  |\r\n| attributeDefaultAllowedValueValue | AlarmAttribute->Attribute_DefaultAllowedValue_Value | object | composite |\r\n| notes | AlarmAttribute->Notes | string |  |\r\n| predefinedValueId | AlarmAttribute->PredefinedValue_Id | integer | int64 |\r\n| predefinedValueDescription | AlarmAttribute->PredefinedValue_Description | string |  |\r\n| predefinedValueValue | AlarmAttribute->PredefinedValue_Value | object | composite |\r\n| sequenceNumber | AlarmAttribute->SequenceNumber | integer | int32 |\r\n| value | AlarmAttribute->Value | object | composite |\r\n",
        "operationId": "GetAlarmAttribute",
        "produces": [
          "application/vnd.onkey.entity+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Alarm Attribute Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Alarm Attribute",
            "schema": {
              "$ref": "#/definitions/GetAlarmAttributeResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Update an existing Alarm Attribute resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | AlarmAttribute->Version | integer | int32 |\r\n| value | AlarmAttribute->Value | object | composite |\r\n| predefinedValueId | AlarmAttribute->PredefinedValue_Id | integer | int64 |\r\n| sequenceNumber | AlarmAttribute->SequenceNumber | integer | int32 |\r\n| notes | AlarmAttribute->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| value | Nullable | True |  |\r\n| predefinedValueId | Nullable | True |  |\r\n\r\n",
        "operationId": "UpdateAlarmAttribute",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Alarm Attribute Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/UpdateAlarmAttributeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Alarm Attribute was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "delete": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Delete an existing Alarm Attribute resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | AlarmAttribute->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "DeleteAlarmAttribute",
        "consumes": [
          "application/vnd.onkey.entitydelete+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Alarm Attribute Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "delete",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/DeleteAlarmAttributeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Alarm Attribute was successfully deleted"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/{alarmId}/Attributes": {
      "get": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Get a collection of Alarm Attribute resources for the Alarm.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | AlarmAttribute->Id | integer | int64 |\r\n| version | AlarmAttribute->Version | integer | int32 |\r\n| sequenceNumber | AlarmAttribute->SequenceNumber | integer | int32 |\r\n| attributeId | AlarmAttribute->Attribute_Id | integer | int64 |\r\n| attributeCode | AlarmAttribute->Attribute_Code | string |  |\r\n| attributeDescription | AlarmAttribute->Attribute_Description | string |  |\r\n| attributeDataType | AlarmAttribute->Attribute_DataType | string (Allowed values: [String, Email, Integer, Long, Float, Currency, DateTime, Date, Time, Duration, Boolean]) | enum |\r\n| predefinedValueId | AlarmAttribute->PredefinedValue_Id | integer | int64 |\r\n| predefinedValueDescription | AlarmAttribute->PredefinedValue_Description | string |  |\r\n| predefinedValueValue | AlarmAttribute->PredefinedValue_Value | object | composite |\r\n| value | AlarmAttribute->Value | object | composite |\r\n| notes | AlarmAttribute->Notes | string |  |\r\n| createdOn | AlarmAttribute->CreatedOn | string | date-time |\r\n| modifiedOn | AlarmAttribute->ModifiedOn | string | date-time |\r\n",
        "operationId": "GetAlarmAttributeCollectionForAlarm",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "alarmId",
            "in": "path",
            "required": true,
            "description": "Alarm Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Alarm Attribute collection",
            "schema": {
              "$ref": "#/definitions/GetAlarmAttributeCollectionForAlarmResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Attributes": {
      "get": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Get a collection of Alarm Attribute resources.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | AlarmAttribute->Id | integer | int64 |\r\n| version | AlarmAttribute->Version | integer | int32 |\r\n| alarmId | AlarmAttribute->Alarm_Id | integer | int64 |\r\n| alarmDescription | AlarmAttribute->Alarm_Description | string |  |\r\n| sequenceNumber | AlarmAttribute->SequenceNumber | integer | int32 |\r\n| attributeId | AlarmAttribute->Attribute_Id | integer | int64 |\r\n| attributeCode | AlarmAttribute->Attribute_Code | string |  |\r\n| attributeDescription | AlarmAttribute->Attribute_Description | string |  |\r\n| attributeDataType | AlarmAttribute->Attribute_DataType | string (Allowed values: [String, Email, Integer, Long, Float, Currency, DateTime, Date, Time, Duration, Boolean]) | enum |\r\n| predefinedValueId | AlarmAttribute->PredefinedValue_Id | integer | int64 |\r\n| predefinedValueDescription | AlarmAttribute->PredefinedValue_Description | string |  |\r\n| predefinedValueValue | AlarmAttribute->PredefinedValue_Value | object | composite |\r\n| value | AlarmAttribute->Value | object | composite |\r\n| notes | AlarmAttribute->Notes | string |  |\r\n| createdOn | AlarmAttribute->CreatedOn | string | date-time |\r\n| modifiedOn | AlarmAttribute->ModifiedOn | string | date-time |\r\n",
        "operationId": "GetAlarmAttributeCollection",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Alarm Attribute collection",
            "schema": {
              "$ref": "#/definitions/GetAlarmAttributeCollectionResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "post": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Create a new Alarm Attribute resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| alarmId | AlarmAttribute->Alarm_Id | integer | int64 |\r\n| attributeId | AlarmAttribute->Attribute_Id | integer | int64 |\r\n| value | AlarmAttribute->Value | object | composite |\r\n| predefinedValueId | AlarmAttribute->PredefinedValue_Id | integer | int64 |\r\n| permissionTreeId | AlarmAttribute->PermissionTree_Id | integer | int64 |\r\n| sequenceNumber | AlarmAttribute->SequenceNumber | integer | int32 |\r\n| notes | AlarmAttribute->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| alarmId | Required | True |  |\r\n| alarmId | Nullable | False |  |\r\n| attributeId | Required | True |  |\r\n| attributeId | Nullable | False |  |\r\n| value | Nullable | True |  |\r\n| predefinedValueId | Nullable | True |  |\r\n| permissionTreeId | System Generated | true | If no value specified |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "CreateAlarmAttribute",
        "consumes": [
          "application/vnd.onkey.entity+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "post",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/CreateAlarmAttributeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - resource was successfully created",
            "headers": {
              "OnKey-Resource-Id": {
                "type": "integer",
                "description": "Id of the resource created",
                "format": "Int64"
              },
              "OnKey-Resource-Location": {
                "type": "string",
                "description": "Uri to fetch the created resource"
              }
            }
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Attributes/Lookups/LookupAlarmAttributeAllowedValue": {
      "get": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Lookup the Attribute Allowed Value for the Alarm Attribute.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | AttributeAllowedValue->Id | integer | int64 |\r\n| description | AttributeAllowedValue->Description | string |  |\r\n| value | AttributeAllowedValue->Value | object | composite |\r\n",
        "operationId": "LookupAlarmAttributeAllowedValue",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Attribute Allowed Value collection",
            "schema": {
              "$ref": "#/definitions/AlarmAttributeAttributeAllowedValueLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Attributes/Lookups/LookupAlarmAttribute": {
      "get": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Alarm Attribute",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Attribute->Id | integer | int64 |\r\n| code | Attribute->Code | string |  |\r\n| description | Attribute->Description | string |  |\r\n| allowAnyValue | Attribute->AllowAnyValue | boolean |  |\r\n| dataType | Attribute->DataType | string (Allowed values: [String, Email, Integer, Long, Float, Currency, DateTime, Date, Time, Duration, Boolean]) | enum |\r\n| defaultValue | Attribute->DefaultValue | object | composite |\r\n| defaultAllowedValueId | Attribute->DefaultAllowedValue_Id | integer | int64 |\r\n| defaultAllowedValueValue | Attribute->DefaultAllowedValue_Value | object | composite |\r\n| defaultAllowedValueDescription | Attribute->DefaultAllowedValue_Description | string |  |\r\n| explanation | Attribute->Explanation | string |  |\r\n",
        "operationId": "LookupAlarmAttribute",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Attribute collection",
            "schema": {
              "$ref": "#/definitions/AlarmAttributeAttributeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Attributes/Lookups/LookupAlarmAttributeChangePermissionTree": {
      "get": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Lookup the permission set for changing the Alarm Attribute.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupAlarmAttributeChangePermissionTree",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable  collection",
            "schema": {
              "$ref": "#/definitions/AlarmAttributeChangePermissionTreeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Attributes/Lookups/LookupAlarmAttributeInsertPermissionTree": {
      "get": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Lookup the permission set for creating the Alarm Attribute.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupAlarmAttributeInsertPermissionTree",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable  collection",
            "schema": {
              "$ref": "#/definitions/AlarmAttributeInsertPermissionTreeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Attributes/Lookups/LookupAlarmAttributeAlarm": {
      "get": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Lookup the Alarm Attribute for the Alarm Attribute.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Alarm->Id | integer | int64 |\r\n| description | Alarm->Description | string |  |\r\n",
        "operationId": "LookupAlarmAttributeAlarm",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Alarm collection",
            "schema": {
              "$ref": "#/definitions/AlarmAttributeAlarmLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Attributes/Batch/{ids}": {
      "get": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Get a collection of Alarm Attribute resources for the set of id's.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| alarmId | AlarmAttribute->Alarm_Id | integer | int64 |\r\n| alarmDescription | AlarmAttribute->Alarm_Description | string |  |\r\n| createdByUserId | AlarmAttribute->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | AlarmAttribute->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | AlarmAttribute->CreatedByUser_FullName | string |  |\r\n| createdOn | AlarmAttribute->CreatedOn | string | date-time |\r\n| isActive | AlarmAttribute->IsActive | boolean |  |\r\n| modifiedByUserId | AlarmAttribute->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | AlarmAttribute->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | AlarmAttribute->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | AlarmAttribute->ModifiedOn | string | date-time |\r\n| permissionTreeId | AlarmAttribute->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | AlarmAttribute->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | AlarmAttribute->PermissionTree_Description | string |  |\r\n| version | AlarmAttribute->Version | integer | int32 |\r\n| id | AlarmAttribute->Id | integer | int64 |\r\n| attributeId | AlarmAttribute->Attribute_Id | integer | int64 |\r\n| attributeCode | AlarmAttribute->Attribute_Code | string |  |\r\n| attributeDescription | AlarmAttribute->Attribute_Description | string |  |\r\n| attributeAllowAnyValue | AlarmAttribute->Attribute_AllowAnyValue | boolean |  |\r\n| attributeDataType | AlarmAttribute->Attribute_DataType | string (Allowed values: [String, Email, Integer, Long, Float, Currency, DateTime, Date, Time, Duration, Boolean]) | enum |\r\n| attributeDefaultValue | AlarmAttribute->Attribute_DefaultValue | object | composite |\r\n| attributeDefaultAllowedValueId | AlarmAttribute->Attribute_DefaultAllowedValue_Id | integer | int64 |\r\n| attributeDefaultAllowedValueDescription | AlarmAttribute->Attribute_DefaultAllowedValue_Description | string |  |\r\n| attributeDefaultAllowedValueValue | AlarmAttribute->Attribute_DefaultAllowedValue_Value | object | composite |\r\n| notes | AlarmAttribute->Notes | string |  |\r\n| predefinedValueId | AlarmAttribute->PredefinedValue_Id | integer | int64 |\r\n| predefinedValueDescription | AlarmAttribute->PredefinedValue_Description | string |  |\r\n| predefinedValueValue | AlarmAttribute->PredefinedValue_Value | object | composite |\r\n| sequenceNumber | AlarmAttribute->SequenceNumber | integer | int32 |\r\n| value | AlarmAttribute->Value | object | composite |\r\n",
        "operationId": "BatchGetAlarmAttribute",
        "produces": [
          "application/vnd.onkey.entitycollection+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "array",
            "name": "ids",
            "in": "path",
            "required": true,
            "description": "A comma separated list of Alarm Attribute id's (eg. 1585760985950002,1585760985950003)",
            "collectionFormat": "csv",
            "x-nullable": false,
            "items": {
              "type": "integer",
              "format": "int64"
            }
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Alarm Attribute collection",
            "schema": {
              "$ref": "#/definitions/BatchGetAlarmAttributeResourceAction"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Attributes/Batch": {
      "post": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Create a new collection of Alarm Attribute resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| alarmId | AlarmAttribute->Alarm_Id | integer | int64 |\r\n| attributeId | AlarmAttribute->Attribute_Id | integer | int64 |\r\n| value | AlarmAttribute->Value | object | composite |\r\n| predefinedValueId | AlarmAttribute->PredefinedValue_Id | integer | int64 |\r\n| permissionTreeId | AlarmAttribute->PermissionTree_Id | integer | int64 |\r\n| sequenceNumber | AlarmAttribute->SequenceNumber | integer | int32 |\r\n| notes | AlarmAttribute->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| alarmId | Required | True |  |\r\n| alarmId | Nullable | False |  |\r\n| attributeId | Required | True |  |\r\n| attributeId | Nullable | False |  |\r\n| value | Nullable | True |  |\r\n| predefinedValueId | Nullable | True |  |\r\n| permissionTreeId | System Generated | true | If no value specified |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchCreateAlarmAttribute",
        "consumes": [
          "application/vnd.onkey.entitycollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "posts",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchCreateAlarmAttributeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - Alarm Attribute batch was successfully created"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Update a collection of existing Alarm Attribute resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | AlarmAttribute->Id | integer | int64 |\r\n| version | AlarmAttribute->Version | integer | int32 |\r\n| value | AlarmAttribute->Value | object | composite |\r\n| predefinedValueId | AlarmAttribute->PredefinedValue_Id | integer | int64 |\r\n| sequenceNumber | AlarmAttribute->SequenceNumber | integer | int32 |\r\n| notes | AlarmAttribute->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| value | Nullable | True |  |\r\n| predefinedValueId | Nullable | True |  |\r\n\r\n",
        "operationId": "BatchUpdateAlarmAttribute",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchUpdateAlarmAttributeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Alarm Attribute batch was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "delete": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Delete a collection of existing Alarm Attribute resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | AlarmAttribute->Id | integer | int64 |\r\n| version | AlarmAttribute->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchDeleteAlarmAttribute",
        "consumes": [
          "application/vnd.onkey.entitydeletecollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "deletes",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchDeleteAlarmAttributeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Alarm Attribute batch was successfully deleted"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Attributes/{id}/Active": {
      "patch": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Change the IsActive status for an existing Alarm Attribute resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | AlarmAttribute->Version | integer | int32 |\r\n| isActive | AlarmAttribute->IsActive | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| isActive | Required | True |  |\r\n| isActive | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeAlarmAttributeIsActive",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Alarm Attribute Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/ChangeAlarmAttributeIsActiveResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Attributes/{id}/PermissionTree": {
      "patch": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Change the PermissionTree for an existing Alarm Attribute resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | AlarmAttribute->Version | integer | int32 |\r\n| permissionTreeId | AlarmAttribute->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeAlarmAttributePermissionTree",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Alarm Attribute Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/ChangeAlarmAttributePermissionTreeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Attributes/Batch/PermissionTree": {
      "patch": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Change the PermissionTree status for a collection of existing Alarm Attribute resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | AlarmAttribute->Id | integer | int64 |\r\n| version | AlarmAttribute->Version | integer | int32 |\r\n| permissionTreeId | AlarmAttribute->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeAlarmAttributePermissionTree",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchChangeAlarmAttributePermissionTreeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/AHM/Alarms/Attributes/Batch/Active": {
      "patch": {
        "tags": [
          "Alarm Attribute"
        ],
        "summary": "Change the IsActive status for a collection of existing Alarm Attribute resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | AlarmAttribute->Id | integer | int64 |\r\n| version | AlarmAttribute->Version | integer | int32 |\r\n| isActive | AlarmAttribute->IsActive | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| isActive | Required | True |  |\r\n| isActive | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeAlarmAttributeIsActive",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchChangeAlarmAttributeIsActiveResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
[...]
